/* $RCSfile: $
 * $Revision: $ $Date: $
 * Auth: Jochen Fritz (jfritz@steptools.com)
 * 
 * 	Copyright (c) 1991-2013 by 
 * 	STEP Tools Inc., Troy, New York
 * 	All Rights Reserved
 * 
 * 	This software is furnished under a license and may be used and
 * 	copied only in accordance with the terms of such license and with
 * 	the inclusion of the above copyright notice.  This software and
 * 	accompanying written materials or any other copies thereof may
 * 	not be provided or otherwise made available to any other person.
 * 	No title to or ownership of the software is hereby transferred.
 * 
 * 		----------------------------------------
 */

P21.Model = (function() {

    function cls(url) {
	this.url = url;
	this.anchor = new P21.Anchor();
	this.reference = new P21.Reference();
	this.auxiliary = new P21.Auxiliary();
    }

    cls.prototype.newInteger = function(val) {return new P21.Integer(val);};
    cls.prototype.newReal    = function(val) {return new P21.Real(val);};
    cls.prototype.newString  = function(val) {return new P21.String(val);};
    cls.prototype.newEnum    = function(val) {return new P21.Enum(val);};
    cls.prototype.newBinary  = function(val) {return new P21.Binary(val);};
    cls.prototype.newURI     = function(val) {return new P21.URI(val);};
    cls.prototype.newID      = function(val) {return new P21.ID(val);};

    cls.prototype.write = function(out_url) {
	// This code assumes that we are copying the old file while updating it.
	// That has two implication:
	// 1. We cannot the old file until the new one is complete.
	// 2. The entire file may need to be read twice (once on read, and
	//    once on write.  This is bad if the file is on the wrong side of
	//    slow network.  We should include the option to cache the entire
	//    content in memory if this is going to be used for URL access.
	
	if (!out_url) out_url = this.url;
	
	if (out_url != this.url)
	    P21.copyUpdateModel(out_url, this);
	else {
	    var tmp = out_url + ".tmp";
	    P21.copyUpdateModel(tmp, this);
	    rename_file(tmp, out_url);
	}
    };

    return cls;
})();


// P21.readModel = function (url) {
//     var model = new P21.Model(url);
//     P21.parseModel(url, model);

//     return model;
// };


P21.ExchangeSection = function() {
}

P21.TaggedExchangeSection = (function() {

    function cls() {};

    cls.prototype = SUBTYPE(P21.ExchangeSection);

    return cls;
    
})();


P21.Anchor = (function() {

    function cls() {
	this.$tag = new P21.Tag();
    };

    cls.prototype = SUBTYPE(P21.TaggedExchangeSection);
    
    return cls;
})();


P21.Reference = (function() {

    function cls() {
	this.$tag = new P21.Tag();
    };

    cls.prototype = SUBTYPE(P21.TaggedExchangeSection);
    
    return cls;
})();


P21.Tag = (function() {

    function cls() {};

    cls.prototype = SUBTYPE(P21.ExchangeSection);

    cls.prototype.$set = function(owner, name, value) {
	var map = this[owner];
	if (!map) {
	    map = {};
	    this[owner] = map;
	}

	map[name] = value;
    }

    cls.prototype.$get = function(owner, name) {
	var map = this[owner];
	if (!map) 
	    return null;

	return map[name];	
    }
    
    return cls;
    
})();


P21.Auxiliary= (function() {

    function cls() {};

    cls.prototype = SUBTYPE(P21.ExchangeSection);
    
    return cls;
})();
